/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	SCORM教材ノードクラス
//			変更履歴
//				2004/01/08	新規作成	二條智文
//

package jp.co.ntt.lms.lo.WBT;

import jp.co.ntt.lms.lo.MaterialNode;
import jp.co.ntt.lms.lo.MaterialNodeList;

/**
 * SCORM教材ノードクラス。<BR>
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public class WbtNode implements MaterialNode {

	/**
	 * 親ノードを保持します
	 */
	private MaterialNode mobjParentNode;

	/**
	 * 子ノードリストを保持します
	 */
	private MaterialNodeList mobjChildList = new WbtNodeList();

	/**
	 * パスを保持します
	 */
	private String mstrPath = "";

	/**
	 * 教材IDを保持します
	 */
	private String mstrMaterialID = "";

	/**
	 * 章IDを保持します
	 */
	private String mstrAuID = "";

	/**
	 * タイトルを保持します
	 */
	private String mstrTitle = "";

	/**
	 * ノード種別を保持します
	 */
	private int mintNodeType = 1;

	/**
	 * コースノード種別です
	 */
	public static final int COURSE_TYPE = 1;

	/**
	 * blockノード種別です
	 */
	public static final int BLOCK_TYPE = 2;

	/**
	 * Auノード種別です
	 */
	public static final int AU_TYPE = 3;


	/**
	 * コンストラクタです。
	 * @param objParentNode 親ノード
	 * @param strAuID 章ID
	 * @param strTitle タイトル
	 */
	public WbtNode( MaterialNode objParentNode, String strAuID, String strTitle ) {
		// メンバ変数にセットします
		mobjParentNode = objParentNode;
		mstrAuID = strAuID;
		mstrTitle = strTitle;

		// パスと教材IDを設定します
		if( objParentNode != null ) {
			mstrPath = objParentNode.getPath() + "/" + strAuID;
			mstrMaterialID = objParentNode.getMaterialID();
			// 親の子ノードに自分を設定します
			objParentNode.addChild( this );
		}
		else {
			mstrPath = "/" + strAuID;
		}
	}

	/**
	 * 親ノードを取得します
	 * @return MaterialNode 親ノード
	 */
	public MaterialNode getParentNode() {
		return mobjParentNode;
	}

	/**
	 * 親ノードを設定します
	 * @param objParentNode 親ノード
	 */
	public void setParentNode( MaterialNode objParentNode ) {
		mobjParentNode = objParentNode;
	}

	/**
	 * 子ノードリストを取得します
	 * @return MaterialNodeList 子ノードリスト
	 */
	public MaterialNodeList getChildList() {
		return mobjChildList;
	}

	/**
	 * 子ノードを追加します
	 * @param objChildNode 子ノード
	 */
	public void addChild( MaterialNode objChildNode ) {
		mobjChildList.add( objChildNode );
	}

	/**
	 * パスを取得します
	 * @return String パス
	 */
	public String getPath() {
		return mstrPath;
	}

	/**
	 * パスを設定します
	 * @param strPath パス
	 */
	public void setPath( String strPath ) {
		mstrPath = strPath;
	}

	/**
	 * 教材IDを取得します
	 * @return String 教材ID
	 */
	public String getMaterialID() {
		return mstrMaterialID;
	}

	/**
	 * 教材IDを設定します
	 * @param strMaterialID 教材ID
	 */
	public void setMaterialID( String strMaterialID ) {
		mstrMaterialID = strMaterialID;
	}

	/**
	 * 章IDを取得します
	 * @return String 章ID
	 */
	public String getAuID() {
		return mstrAuID;
	}

	/**
	 * 章IDを設定します
	 * @param strAuID 章ID
	 */
	public void setAuID( String strAuID ) {
		mstrAuID = strAuID;
	}

	/**
	 * タイトルを取得します
	 * @return String タイトル
	 */
	public String getTitle() {
		return mstrTitle;
	}

	/**
	 * タイトルを設定します
	 * @param strTitle タイトル
	 */
	public void setTitle( String strTitle ) {
		mstrTitle = strTitle;
	}

	/**
	 * ノード種別を取得します
	 * @return int ノード種別
	 */
	public int getNodeType() {
		return mintNodeType;
	}

	/**
	 * ノード種別を設定します
	 * @param intNodeType ノード種別
	 */
	public void setNodeType( int intNodeType ) {
		mintNodeType = intNodeType;
	}

	/**
	 * パスを指定して、子ノードリストからノードを検索します
	 * @param strPath パス
	 * @return MaterialNode 検索結果 見つからない場合はnull
	 */
	public MaterialNode searchChild( String strPath ) {
		if( strPath.equals( mstrPath ) ) {
			return this;
		}
		mobjChildList.first();
		while( mobjChildList.hasNext() ) {
			// 子ノードを取得
			MaterialNode objChildNode = mobjChildList.next();
			MaterialNode objResultNode = objChildNode.searchChild( strPath );
			// 検索結果がnullではない場合はその結果を返す
			if( objResultNode != null ) {
				return objResultNode;
			}
		}
		// 検索で何も見つからない場合はnullを返す
		return null;
	}

	/**
	 * IDを指定して、子ノードリストからノードを検索します
	 * @param strAuID AuID
	 * @return MaterialNode 検索結果 見つからない場合はnull
	 */
	public MaterialNode searchAUID( String strAuID ) {
		if( strAuID.equals( mstrAuID ) ) {
			return this;
		}
		mobjChildList.first();
		while( mobjChildList.hasNext() ) {
			// 子ノードを取得
			MaterialNode objChildNode = mobjChildList.next();
			MaterialNode objResultNode = objChildNode.searchAUID( strAuID );
			// 検索結果がnullではない場合はその結果を返す
			if( objResultNode != null ) {
				return objResultNode;
			}
		}
		// 検索で何も見つからない場合はnullを返す
		return null;
	}

}